







ExtraDOS Toolbox (tm)
_______________________________________

  Users Manual




















Copyright (c) 1985-95 HyperWare  All Rights Reserved


Introduction
_____________________________________________________________________


ExtraDOS Toolbox is a compilation of tools useful to Microsoft DOS
users.  I originally wrote the first version of ExtraDOS under MS-DOS
because I found a need for them and there were no commercially
available products that provided these functions.  Some ExtraDOS tools
were designed to enhance programs already found in MS-DOS.  Other
tools were familiar to the Unix world, but were not available in
MS-DOS.  Over the years this collection has grown into large group of
very useful tools.  Some of these utilities are duplicates of those
found elsewhere, but often provide much better features or reduced
memory overhead than similar utilities found elsewhere.  In addition,
ExtraDOS complements PC-Tools and Norton Utilities with added tools
these programs do not provide.

Over thirty of the ExtraDOS Toolbox utilities have been selected by
Paul Somerson, former Executive Editor of PC Magazine, for Bantam
Books', DOS Power Tools, 2nd Edition, Revised and Expanded for DOS
5.0.  Many of the ExtraDOS Toolbox utilities are now appearing in many
popular DOS books that feature shareware enhancements for DOS.

I hope you find these tools useful and convienent.  Any suggestions
for enhancements, improvements or additions are welcome.  Please
contact use with your comments.


David R. Foley

License Agreement
_____________________________________________________________________


  This software is protected by both United States' copyright law and
  international treaty provisions. Therefore, you must treat this
  software "just like a book," with the following single exception.
  HyperWare authorizes you to make archival copies of the software for
  the sole purpose of backing up our software and protecting your
  investment from loss. By saying, "just like a book," HyperWare means
  that this software may be used by any number of people and may be
  freely moved from one computer location to another, provided there
  is absolutely no possibility of it being used at one location while
  it is being used at another. Just as a book cannot be read by two
  different people in two different places simultaneously, the
  software may not be used by two different people in two different
  places simultaneously.

  You may not make copies of the software documentation or disk,
  except as described above. You may not distribute, rent, sublicense,
  or lease the software or the documentation. You may not alter,
  modify, or adapt the software or documentation, including but not
  limited to translating, decompiling, reverse assembling, or creating
  derivative works. You may not use the software in a network,
  timeshareing, multiple CPU, or multi- user environment unless each
  user is licensed by HyperWare.


EXTRADOS TOOLBOX
_____________________________________________________________________


LIMITED WARRANTY

  Upon notification of defects in material or workmanship, within the
  warranty period of 45 days from the date of purchase, HyperWare
  will, at its option, replace the defective diskette or refund the
  license fee. If you need to return a product, call the HyperWare
  Technical Support Service Department to obtain a return
  authorization number. The remedy for breach of this warranty shall
  be limited to replacement or refund and shall not encompass any
  other damages, including but not limited to loss of profit, and
  special, incidental, consequential, or other similar claims.

  HyperWare specifically disclaims all other warranties, expressed or
  implied, including but not limited to implied warranties of
  merchantability and fitness for a particular purpose with respect to
  defects in the diskette and documentation, and the program license
  granted herein in particular, and without limiting operation of the
  program license with respect to any particular application, use, or
  purpose. In no event shall HyperWare be liable for any loss of
  profit or any other commercial damage, including but not limited to
  special, incidental, consequential, or other damages. This statement
  shall be construed, interpreted, and governed by the laws of the
  State of California.


TRADEMARK INFORMATION

  ExtraDOS Toolbox, TurboBAT, SpeedRAM, Screen Manager, Profiler,
  WizLabel, CDBS, Press Gate Manager, ExtraWindows Toolbox and Safety
  Disk are trademarks of HyperWare.

  MS-DOS and Windows are trademarks of Microsoft Corporation.

  Norton Utilities are a trademark of Symantec.

  PC-Tools is a trademark of Central Point Software.


EVAL - DOS Command Line Calculator
_____________________________________________________________________


DESCRIPTION

  EVAL is a program designed to evaluate mathematical expressions
  input on the command line.


VERSION

  5.00  05/023/95


COMMAND FORMAT

  EVAL [expression][function][expression]...


NOTES

  EVAL supports the four basic functions; addition, multiplication,
  subtraction, and division.  The syntax used is very similar to that
  of the mathematic expressions used by most modern computer languages
  and by most spreadsheet programs.  For example, to add two to eight
  and multiply that result by thirteen, one would use:

  EVAL (2+8)*13


EVAL - DOS Command Line Calculator
_____________________________________________________________________


EXPONENTS

  The operator precedence used is similar to most high level
  languages, as well.  Multiplication and division are "higher" than
  addition and subtraction. Exponents, represented by the carat (^)
  are lower than all four operators. You will find that you can
  exponentiate values by using ** in place of the carat.  Thus, you
  can use:  EVAL 2**1/2 to find 2^0.5.

  It should be noted, by the way, that this is a good way to find
  roots.  The program has no sqrt() or curt() functions.  You may
  recall from your math courses that, to find the y-th root of x, you
  can do:  x^(1/y)

  Of course, EVAL will complain if this results in a complex number.
  For example, the result of the above is complex if x == -4 and
  y == 4.


RANGE

  EVAL uses the full "double" precision of the C language.  Thus,
  answers will be represented to a maximum of 16 digits to the right
  of the decimal point. EVAL allows all numbers between 1.7E-308 and
  1.7E+308 to exist. Of course, the negatives of these numbers are
  also available.  It should be noted that EVAL doesn't check for
  overflows or underflows.  EVAL will, however, flag "digital math"
  nono's, such as division by zero and exponentiations resulting in
  complex numbers.  To use these numbers, just write them as you would
  specify them in a program like 1-2-3 or in a program: 3.1415 0.1 -34
  18.01 35e-2 6.2e+23


EVAL - DOS Command Line Calculator
_____________________________________________________________________


MODULO DIVISION

  EVAL, as well as complementing the four functions with
  exponentiation, allows the use of the modulo operator.  This
  operator provides the integral "remainder" of division.  Since 5
  divided by two is two remainder one, the command:  EVAL 5%2  will
  result in the answer 1.0.


FUNCTIONS

  EVAL supports an extensive list of functions, as well.  Functions
  may be specified in either upper or lower case, and may be
  abbreviated to as little as three characters.  (Of course, if the
  function's name is one or two characters long, all characters must
  be specified.)


  These functions are supported by EVAL:

  abs(x)         absolute value of x
  acos(x)        arc cos of the angle x radians
  acot(x)        arc cotangent of the angle x radians
  acsc(x)        arc cosecant of the angle x radians
  asec(x)        arc secant of the angle x radians
  asin(x)        arc sine of the angle x radians
  atan(x)        arc tangent of the angle x radians
  cos(x)         cosine of the angle x radians
  cot(x)         cotangent of the angle x radians
  csc(x)         cosecant of the angle x radians
  deg(x)         convert x radians to degrees
  exp(x)         e to the power of x
  fact(x)        factorial of x
  random(x)      random number (see below)


EVAL - DOS Command Line Calculator
_____________________________________________________________________


  ln(x)          natural (base e) logarithm of x
  log(x)         base 10 logarithm of x
  pi(x)          pi times x
  rad(x)         converts x degrees to radians
  sec(x)         secant of the angle x radians
  sin(x)         sine of the angle x radians
  tan(x)         tangent of the angle x radians
  sinh(x)        hyperbolic sine of x
  cosh(x)        hyperbolic cosine of x
  tanh(x)        hyperbolic tangent of x
  sech(x)        hyperbolic secant of x
  csch(x)        hyperbolic cosecant of x
  Random(x)      random number (see below)

  If any of these functions are passed invalid values, EVAL will abort
  with an error.  The arc-trig functions, for example, cannot accept
  values outside of the closed interval [0,1].

  Using these functions is similar to any other high level language.
  The function name and its ending left parenthesis function as an
  opening parenthesis in the precedence of the evaluation.  Thus,
  sin(.7)^2+cos(.7)^2 would evaluate to 1.0.  You may find that
  certain identities don't evaluate to what you would expect them to.

  This is because of the limits of precision in computer math when
  dealing with irrational numbers.  While the sin^2+cos^2 identity
  almost always works, the sec^2-tan^2 identity usually doesn't work,
  for example.

  Along with this problem, another comes.  For example, mathematically
  sec(0.5*pi) is undefined.  However, EVAL will evaluate sec(pi(0.5))
  to be a very (very) large number.  This is again because of the
  rounding errors in binary math. It is a good approximation,
  considering lim(sec(x)) == +infinity   x -> 0.5+


EVAL - DOS Command Line Calculator
_____________________________________________________________________


RANDOM(X)

  If X is specified, returns a random integer in the range 0..X-1.
  If X is not specifed, returns a random floating point number in
  the range 0 < N < 1.0.

  This function uses the environment variable SEED= as the pseudo-
  random number seed (this number is in the range 0 < SEED < 1.0).
  If this variable is not defined or is not a proper number it will
  be initialized using the computer's current time.


MEMORY

  By popular demand, a "memory" feature has been added to EVAL.  If
  you make a computation using EVAL, the result is remembered and may
  be used as needed in any further invocation of EVAL.

  For example, using the command: EVAL SIN(1)  would display the sine
  of one radian.  If you executed the command:  EVAL ASIN(@)  next,
  you'd get, effectively, ASIN(SIN(1))... the result would be one.
  Similarly, if you used EVAL  35+15  EVAL would print 50.  If you did
  EVAL @+100  a result of 150 would be displayed.

  EVAL stores the results in your machine's environment.  You may see
  the previous result by typing the SET command; DOS will list the
  environment variables it has stored.  EVAL's environment variable is
  listed on the line "EVAL".

PARSING PROBLEM

  Currently, there is a problem when parsing functions with
  parenthesis.  When parsing a function, such as SIN(x), with an
  additional computation that follows, e.g. SIN(1)+1, it evaluates
  the expression as SIN(1+1).  To correct this, place extra
  parenthesis around the function, e.g. (SIN(1))+1.

  This problem should be corrected in the next release.


TECHNICAL SUPPORT
_____________________________________________________________________


  Often we get calls from people asking questions that can be
  solved easily by checking through the manual before calling tech
  support. We ask that you browse the manual and look for information
  pertaining to your particular problem before calling. This can often
  save you time, as we take a collection of our most common questions
  and try to address them in this manual.

  We offer alternative methods besides the conventional phone
  support, such as a multi-line 24-hour BBS system. We also monitor
  most technical conferences in the BBS Interlink and RelayNet
  networks as well as many conferences on the CompuServe
  Information System. You may send messages and questions via any of
  these services.

  Currently our Tech Support office is staffed Monday through Friday
  from 9:00 a.m. to 5:00 p.m. Pacific Time. There is a chance,
  however, that someone is in the office outside this time frame.
  If so, we will gladly answer your questions outside the normal
  business hours.  Registered users are given unlimited technical
  support.

  HyperWare
  Technical Support Department
  185 Berry Street
  San Francisco, CA  94107
  (415) 882-1740
  (415) 882-1733 FAX
  (415) 882-1735 BBS
  PCVENB CONF. 13 CompuServe


CREDITS
_____________________________________________________________________


  This collection of utilities started out as a small set of home
  grown tools that I just could not stand to live without.  Many times
  someone would see me using them and ask for a copy.  This was a big
  mistake.  All of the sudden I had to debug my code.  Someone would
  call me up and remind me of some problem with a utility that I had
  written or asked me to just add this one little feature.  Six years
  later the package has evolved to its current state.  Along the way I
  have had the help of many people in testing and ideas for products.
  I would like to thank all of those people who have of course
  registered these utilities as this is now a new incentive for
  continuing to expand them.  More specifically I'd like to thank the
  following:

  Kathy Smith
  Jay Wessel
  Roger Cross
  Brian & Tess for Channel 1
  Paul Somerson & Bantam Books
  PC Tech Journal (A Great Loss)
  PC Magazine
  Byte Magazine
  Jerry Pournelle
  Association of Shareware Professionals




PROGRAMMING

  The ExtraDOS Toolbox utilties use a wide variety of programming
  tools including:

  Borland Turbo Pascal 7.0
  Borland Turbo Assembler 3.0
  Borland Turbo C++ 1.0
  Borland Turbo Debugger 2.0
  Turbo Power Software Object Professional 1.0
  Phil Katz' PKLite Professional 1.13
  Unity Programmers Editor 3.33
  Ralph Browns' Interrupt List


  Programming by:

  Mike Blaszczak
  David Foley
  Joe Halpin
  Bill McKee
  Mike Molloy
  Mike Viens
  Ross Neilson Wentworth
  Randall Woodman


CREDITS
_____________________________________________________________________



ART

  Artwork for the ExtraDOS Toolbox was created using:

  Ian Davis' TheDraw 4.01
  Aldus Freehand 2.0
  Electronic Arts Studio/8 2.0


  Art by:

  David Foley
  Noel Gamboa
  Moses Gates
  Shahasp Herardian
  Pat McSween
  Ross Neilson Wentworth


DOCUMENTATION

  Documentation for the ExtraDOS Toolbox was written using:

  FHTS SuperEdit 3.04
  Word Perfect 5.1
  MS Word for Windows 2.0
  Grammatik for Windows 1.0
  Aldus Pagemaker 4.0
  Unity Programmers Editor 3.33


  Documentation by:

  Mike Blaszczak
  David Foley
  Mike Viens
  Ross Neilson Wentworth



LICENSE INFORMATION

  CHIMES, EVAL and RAMDRIVE are derivatives of the Nifty James
  utilties by Mike Blaszczak.

  FILEATTR and  NAMEDIR are derivatives of the Fantastic
  Utilities by Mike Viens.


FHTS Products
_____________________________________________________________________


Safety Disk (tm)

  Safety Disk saves all of your systems vital information and will
  solve most problems due to:  Loss of battery power, Loss of CMOS
  information, accidental deletion of boot files, virus damage to boot
  disk.


  "Use Safety Disk and your PC is Safe.", Computer Shopper, March 1992

  "Used in Conjuntion with a conventional backup utility, Safety Disk,
   for $59.95 will provide as bulletproof a backup as you're likely to
   find in the PC marketplace.", InfoWorld, February 10, 1992

  "Safety Disk is so deceptively easy to use that it makes hard-drive
   and computer maintenance seem impossibly easy.", PCM Magazine, May
   1992

  "I have discovered the most unique and useful system maintenance
   utility since Spinrite came along.", MBUG PC Newsletter, December,
   1991


ExtraDOS Toolbox (tm)

  A large collection of over 50 utilities that DOS forgot. Includes
  many helpful utilities that enhance MS-DOS machines. Featured in the
  DOS Power Tools, 2nd Edition, Revised for DOS 5.0 book by Bantam
  Books.


WizLabel (tm)

  Print Sharp Wizard phone listings directly to your SLP Printer
  without having to convert your data.


Coach Database System.

  CDBS provides a method for tracking and evaluating NBA teams, NBA
  players, and college players. It supplies a comprehensive report
  generator for building decision support reports on scouted players.


FHTS Products
_____________________________________________________________________



Press Gate Manager.

  Software for event organizers. Creates and maintains a database of
  events and guests with the ability to track seating by type,
  location, and person. Produces seating charts and labels for press
  passes.


FINDB.

  Financial Database System for tracking shareholders in a company.
  Allows the instant retrieval of information based on any part of a
  persons account id, ss#, zip code etc.  Has support for completely
  customized HP Laserjet tax forms.  Ideal for generating K1 tax
  reports for limited partnerships.


